#ifndef AMBARESPONSE_H_
#define AMBARESPONSE_H_

#include "enum_slave_sig.h"


namespace slave{

/**
 * @author Andre Silva
 * @author Guilherme Alvaro
 * 
 * @brief AmbaRequest Class
 */
	class AmbaResponse {
		public:

	       /**
			 * @brief Status of transaction
			 */   
			bool HREADY;

	       /**
			 * @brief Type of response of transaction: OKAY, RETRY, etc.
			 */   
			Amba_HRESP_Type HRESP;

	       /**
			 * @brief Operator of Copy
	 		 * @param[in] const AmbaRequest &right: reference for Amba Response that will be copied
	 		 * @return AmbaResponse& Copy of Amba Response
			 */   		
			AmbaResponse& operator=(const AmbaResponse &right){
				this->HREADY = right.HREADY;
				this->HRESP = right.HRESP;
				return *this;
			}
	};
	
};

#endif /*AMBARESPONSE_H_*/
