#include "amba_slave.h"
#include "amba_decoder.h"
#include "util.h"

int AmbaSlave::getId() const{
	return this->id;	
}

			
int AmbaSlave::getBase() const{ 
	return this->base;	
}
			
int AmbaSlave::getOffset() const{
	return this->offset; 
}

AmbaSlave::AmbaSlave(sc_module_name nm, int size):sc_module(nm){
	
	if(size < 0){
		memory = new char[1];
		this->offset = 1;
	} else
	if(size > 1024){
		memory = new char[1024];
		this->offset = 1024;
	}else{
		memory = new char[exponentialBase2(size)];
		this->offset = exponentialBase2(size);
	}
}

AmbaSlave::AmbaSlave():sc_module("slave_default"){}

AmbaSlave::AmbaSlave(sc_module_name nm):sc_module(nm){}



void AmbaSlave::getAmbaSlave_default(AmbaSlave* slave_default){

		slave_default = new AmbaSlave("slave_default");
		slave_default->memory = new char[1024];
		slave_default->id = 16;
		slave_default->base = -1;
}
	
AmbaSlave::~AmbaSlave(){
}


AmbaSlave& AmbaSlave::operator=(const AmbaSlave &right){
	this->id = right.getId();
	this->base = right.getBase();
	this->offset = right.getOffset();
	right.getMemory(this->memory);
	return *this;
}

void AmbaSlave::getMemory(char*& mem) const{
	int tam = this->getOffset();
	if (mem != 0)
		delete[] mem;
	
	mem = new char[tam];
	for (int i=0; i < tam; i++)
		mem[i] = this->memory[i]; 
}

AmbaSlave::AmbaSlave(const AmbaSlave&){
	
}

Amba_AHB_Rsp AmbaSlave::transport(const Amba_AHB_Req& amba_ahb_req){
	Amba_AHB_Rsp rsp;
	return rsp;
}

void AmbaSlave::setId(int id){
	this->id = id;
}

void AmbaSlave::setBase(int base){
	this->base = base;
}


void AmbaSlave::setOffset(int offset){
	this->offset = offset;	
}

AmbaSlave::AmbaSlave(sc_module_name nm, int base, int offset):sc_module(nm){
	
	if(base >= 0xFFFFFFFF || base < 0x0)
	    cout << "SLAVE: Base address error." << endl;
	else{
		if(offset >= 0xFFFFFFFF || offset < 0x0)
		  cout << "SLAVE: Offset address error." << endl;	
		else{
			this->base = base;
			this->offset = offset;
		}	
	}
}

