#include "WrapperMasterAmbaTLM.h"

WrapperMasterAmbaTLM::WrapperMasterAmbaTLM(sc_module_name nm, AmbaBus* bus, AmbaMaster* master):
portBus(*bus),sc_module(nm)
{
	this->master = master;
	portMaster(*this);
}

Amba_AHB_Rsp WrapperMasterAmbaTLM::transport(const Amba_AHB_Req& amba_ahb_req){
//	Resposta
	print_log("WrapperMasterAmba: Definindo Resposta");
//	AmbaData data(16);
	Amba_AHB_Rsp resp; 
//	resp.amba_data = data;
// Variaveis criadas devido ao const
	if (amba_ahb_req.amba_request.HBUSREQ){  
		print_log("WrapperMasterAmba: Criando Variaveis devido ao const");
		AmbaRequest req = amba_ahb_req.amba_request;
		AmbaData data = amba_ahb_req.amba_data;

//		cout << "Endereço inicial: " << &data << endl;	

		print_log("WrapperMasterAmba: Requisitando o barramento");
	
		if (!portBus->is_master(*master))
			portBus->master_request_bus_blocking(*master, amba_ahb_req.req_type);
	
		print_log("WrapperMasterAmba: Enviando os sinais de controle"); 
		portBus->master_send_controls_signals(*master, req);
	
		if (amba_ahb_req.amba_request.HWRITE)
			do{
				print_log("WrapperMasterAmba: Enviando os dados");
				portBus->master_send_data(*master, data, resp.amba_response);
				if (resp.amba_response.HRESP == RETRY || resp.amba_response.HRESP == SPLIT){
					if (!portBus->is_master(*master))
						portBus->master_request_bus_blocking(*master, amba_ahb_req.req_type);
					portBus->master_send_controls_signals(*master, req);
				}
			}while(!end_transport(resp));
		else
			do{
				print_log("WrapperMasterAmba: Lendo os dados");
				portBus->master_read_data(*master, resp.amba_data, resp.amba_response);
				print_log("WrapperMasterAmba: Leu os dados"); 
				if (resp.amba_response.HRESP == RETRY || resp.amba_response.HRESP == SPLIT){
					if (!portBus->is_master(*master))
						portBus->master_request_bus_blocking(*master, amba_ahb_req.req_type);
					portBus->master_send_controls_signals(*master, req);
				}
			}while(!end_transport(resp));
	}
		else
		{

			print_log("WrapperMasterAmba: Liberando o barramento");
			portBus->master_release_bus(*master);
		}
	
	print_log("WrapperMasterAmba: Return resp");
	return resp; 
} 
