#include "WrapperSlaveAmbaTLM.h" 


WrapperSlaveAmbaTLM::WrapperSlaveAmbaTLM(sc_module_name nm, AmbaBus* bus, AmbaSlave* slave): 
portBus(*bus),
portSlave(*slave),
sc_module(nm) 
{ 
	//here
	bus->register_slave(slave);
	SC_THREAD(simulate_transport_thread);
       sensitive << transport_event;
       dont_initialize();
    SC_THREAD(simulate_slave_thread);
   	this->slave = slave;
   	is_transport = false;
   	is_split = false;
}

void WrapperSlaveAmbaTLM::simulate_slave_thread(){
	cout << this->name()<<": WrapperSlaveAmbaTLM comecou" <<endl;
	AmbaData data;
	
	while (true){
		portBus->slave_receive_controls_signals(*slave, req.amba_request);	
		cout << "WrapperSlaveAmbaTLM: Recebeu sinais de controle "<< sc_time_stamp() << endl;
		
		if(!is_transport){

			if (!is_split){
			
				if(rsp.amba_response.HRESP == SPLIT)
					is_split = true;
				if (req.amba_request.HWRITE){	
					this->createDefaultResponse();
					portBus->slave_read_data(*slave, this->resp, req.amba_data);
					cout << "WrapperSlaveAmbaTLM: leu dados "<< sc_time_stamp() << endl;
					is_transport = true; 
					transport_event.notify();
				}
				else
				{
					transport_event.notify();
					wait(resp_transport_event);
					portBus->slave_send_data(*slave,this->rsp.amba_response, this->rsp.amba_data);
					cout << "WrapperSlaveAmbaTLM: enviou dados "<< sc_time_stamp() << endl;
				}
					
			}
			else
				if(rsp.amba_response.HRESP != SPLIT){
					portBus->slave_end_split(*slave);
					is_split = false;
				}
		}
		else{
			this->createRetryResponse();
			cout << "WrapperSlaveAmbaTLM: Criou Retry "<< sc_time_stamp() << endl;

			if(req.amba_request.HWRITE)
				portBus->slave_read_data(*slave, this->resp, data);
			else
				portBus->slave_send_data(*slave,this->resp, data);
		}
	}
}


void WrapperSlaveAmbaTLM::simulate_transport_thread(){

	while (true){
		rsp = portSlave->transport(req);
		cout << "wrapperSlave enviou transport: " << endl;
		resp_transport_event.notify();
		is_transport = false;
		wait();
	}
}

void WrapperSlaveAmbaTLM::createDefaultResponse(){
	this->resp.HREADY = true;
	this->resp.HRESP = OKAY;
}


void WrapperSlaveAmbaTLM::createRetryResponse(){
	this->resp.HREADY = false;
	this->resp.HRESP = RETRY;
}
