#ifndef AMBA_AHB_REQ_H_
#define AMBA_AHB_REQ_H_

#include "amba_request.h"
#include "amba_data.h"
#include "enum_master_sig.h"
#include "amba_master.h"

using namespace master;
using namespace amba;

/**
 * @brief Struct that represents the request package in TLM pattern
 * @author Andre Silva
 * @author Guilherme Alvaro
 */

struct Amba_AHB_Req
{

	/**
	 * @brief The Amba_Request_Type
	 */
	Amba_Request_Type req_type;

	/**
	 * @brief The AmbaRequest package
	 */

	AmbaRequest amba_request;

	/**
	 * @brief The AmbaData package
	 */

	AmbaData amba_data;


	/**
	 * @brief Overload of the = operator
	 * @param const Amba_AHB_Req & right: The Amba_AHB_Req  to be copied
	 * @return const Amba_AHB_Req: The Amba_AHB_Req copied
	 */


	const Amba_AHB_Req &operator=(const Amba_AHB_Req & right){
		this->req_type = right.req_type;
		this->amba_request = right.amba_request;
		this->amba_data = right.amba_data;
		return *this;
	}
	
};

#endif /*AMBA_AHB_REQ_H_*/
