#ifndef AMBA_AHB_RSP_
#define AMBA_AHB_RSP_

#include "amba_response.h"
#include "amba_data.h" 
#include "amba_slave.h"

using namespace amba;
using namespace slave;

class AmbaSlave;

/**
 * @brief Struct that represents the response package in TLM pattern
 * @author Andre Silva
 * @author Guilherme Alvaro
 */


struct Amba_AHB_Rsp{

	/**
	 * @brief The AmbaResponse package
	 */

	AmbaResponse amba_response;

	/**
	 * @brief The AmbaData package
	 */
	AmbaData amba_data;
	

	/**
	 * @brief Overload of the = operator
	 * @param const Amba_AHB_Rsp & right: The Amba_AHB_Rsp to be copied
	 * @return const Amba_AHB_Rsp: The Amba_AHB_Rsp copied
	 */

	const Amba_AHB_Rsp &operator=(const Amba_AHB_Rsp & right){
		this->amba_response = right.amba_response;
		this->amba_data = right.amba_data;
		return *this;
	}
	
};

#endif /*AMBA_AHB_RSP_*/
