/**
 * @author Andre Silva
 * @author Guilherme Alvaro
 * 
 * @brief Util Namespace
 */
#ifndef UTIL_H_
#define UTIL_H_

#include <math.h>

//Auxiliar functions
namespace util{

	/** 
	 * @brief Calculates the logarithm
	 * @param[in] double antiLog: 
	 * @param[in] int base:
	 */	
	double logbase(double antiLog, int base);


	/** 
	 * @brief Calculates the exponential of the base in the function parameter's
	 * @param[in] int num: base
	 * @return int exponential of the base
	 */	
	int exponentialBase2(int num);
	
	/** 
	 * @brief Prints Log in video
	 * @param[in] char* log: log that will be printed in video
	 */	
	void print_log(char* log);
	
	/** 
	 * @brief Prints Log with a Name in video
	 * @param[in] char* name: name that will be printed in video
	 * @param[in] char* log: log that will be printed in video
	 */	
	void print_log(char* name, char * log);
	
}
  
#endif /*UTIL_H_*/
